Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

%define bname   groovy
%define beta    jsr04


Name:           %{bname}-jsr
Summary:        Groovy (JSR-241) scripting language
Url:            http://groovy.codehaus.org/
Version:        1.0
Release:        alt1_0.jsr04.2jpp5
Epoch:          0
License:        BSD/Apache-style Software License
Group:          Development/Java
Source0:        groovy-1.0-jsr-04-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        groovy-1.0-jsr-04-jpp-depmap.xml
Source5:        groovy.policy
Patch0:         groovy-1.0-jsr-04-jpp.patch
Patch1:         groovy-1.0-jsr-04-maven_xml.patch
Patch2:         groovy-1.0-jsr-04-startGroovy.patch
Patch3:         groovy-1.0-jsr-04-tck-build_xml.patch

BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: ant >= 0:1.6
BuildRequires: ant-junit >= 0:1.6
BuildRequires: junit
BuildRequires: maven-plugins >= 0:1.1
BuildRequires: antlr
#
BuildRequires: asm2
BuildRequires: axion
BuildRequires: bsf
BuildRequires: cglib
BuildRequires: jakarta-commons-cli
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-httpclient
BuildRequires: jakarta-commons-lang
BuildRequires: jakarta-commons-logging >= 0:1.1
BuildRequires: jakarta-commons-primitives
BuildRequires: jarjar
BuildRequires: jmock
BuildRequires: mockobjects
BuildRequires: mx4j >= 0:3.0
BuildRequires: nekohtml
BuildRequires: jakarta-oro
BuildRequires: qdox
BuildRequires: radeox
BuildRequires: regexp
BuildRequires: servletapi4
BuildRequires: xerces-j2
BuildRequires: xml-commons-apis
BuildRequires: xpp3
BuildRequires: xstream
#
Requires: antlr
Requires: asm2
Requires: jakarta-commons-cli
Requires: jakarta-commons-logging
Requires: jarjar
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
Groovy is a new agile dynamic language for the JVM 
combining lots of great features from languages like 
Python, Ruby and Smalltalk and making them available 
to the Java developers using a Java-like syntax.
Groovy is designed to help you get things done on the 
Java platform in a quicker, more concise and fun way - 
bringing the power of Python and Ruby inside the Java 
platform. 
Groovy can be used as an alternative compiler to javac 
to generate standard Java bytecode to be used by any 
Java project or it can be used dynamically as an 
alternative language such as for scripting Java objects, 
templating or writing unit test cases.


%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n groovy-1.0-jsr-04/
chmod -R go=u-w *
for j in $(find . -name "*.jar"); do
      mv $j $j.no
done
mkdir security
cp %{SOURCE5} security
mkdir xdocs

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav

export DEPCAT=$(pwd)/groovy-1.0-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > groovy-1.0-depmap.new.xml

for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done


%build
export MAVEN_OPTS=-XX:MaxPermSize=512m

mkdir -p .maven/repository/JPP/plugins/
pushd .maven/repository/JPP/plugins/
ln -sf /usr/share/maven/plugins/maven-xdoc-plugin-*.jar maven-xdoc-plugin.jar
popd

maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$(pwd)/.maven \
	-Dmaven.compile.target=1.4 \
	-Dmaven.javadoc.source=1.4 \
        default
mv maven.xml maven.xml.no
maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=$(pwd)/.maven \
	-Dmaven.compile.target=1.4 \
	-Dmaven.javadoc.source=1.4 \
	javadoc:generate xdoc:transform

# delete DOS files
rm target/install/bin/*.bat

%install
find . -name "*.sav" -exec rm {} \;
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 target/install/lib/%{bname}-%{version}-jsr-04.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 target/install/lib/%{bname}-starter.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-starter-%{version}.jar
install -m 644 target/install/embeddable/%{bname}-all-%{version}-jsr-04.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-all-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# bin
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -m 755 target/install/bin/grok $RPM_BUILD_ROOT%{_bindir}/grok-jsr
install -m 755 target/install/bin/groovy $RPM_BUILD_ROOT%{_bindir}/groovy-jsr
install -m 755 target/install/bin/groovyc $RPM_BUILD_ROOT%{_bindir}/groovyc-jsr
install -m 755 target/install/bin/groovyConsole $RPM_BUILD_ROOT%{_bindir}/groovyConsole-jsr
install -m 755 target/install/bin/groovysh $RPM_BUILD_ROOT%{_bindir}/groovysh-jsr
install -m 755 target/install/bin/startGroovy $RPM_BUILD_ROOT%{_bindir}/startGroovy-jsr
for s in $RPM_BUILD_ROOT%{_bindir}/gro*-jsr; do
        sed -e '/dirname/s/startGroovy/startGroovy-jsr/' $s > tmpf
        cp tmpf $s
done
rm tmpf

# conf
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf
install -m 644 target/install/conf/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/conf

# lib
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/lib
pushd $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/lib
ln -sf %{_javadir}/groovy-jsr-starter.jar groovy-starter.jar
ln -sf %{_javadir}/groovy-jsr.jar groovy-jsr.jar
ln -sf $(build-classpath antlr)
ln -sf $(build-classpath asm2/asm2-analysis)
ln -sf $(build-classpath asm2/asm2-attrs)
ln -sf $(build-classpath asm2/asm2-util)
ln -sf $(build-classpath asm2/asm2-tree)
ln -sf $(build-classpath asm2/asm2)
ln -sf $(build-classpath commons-cli)
ln -sf $(build-classpath commons-logging)
ln -sf $(build-classpath jarjar)
popd

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

%clean

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%preun
if [ "$1" = "0" ]; then
  rm %{_datadir}/%{name}-%{version}/lib/*.jar
fi

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%doc LICENSE.txt
%{_javadir}/*
%attr(755, root, root) %{_bindir}/*
%{_datadir}/%{name}-%{version}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}*-%{version}.jar.*
%endif

%files javadoc
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Tue Dec 02 2008 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt1_0.jsr04.2jpp5
- fixed build with java 5

* Thu Nov 15 2007 Igor Vlasenko <viy@altlinux.ru> 0:1.0-alt1_0.jsr04.2jpp1.7
- converted from JPackage by jppimport script

